#pragma once
#if _WIN32_WINNT < 0x0400
#  undef _WIN32_WINNT
#  define _WIN32_WINNT 0x0400
#endif
#include <windows.h>
#include "CHardware.h"

// !!! IMPORTANT !!!
// While inhereting CHWCPU make sure to call InitCPU() in the child constructor!
// !!! IMPORTANT !!!

class CHWCPU : public CHardwareWithStdInt
{
  protected:
    bool InstructionInProgress;

    // Fiber stuff
    enum FiberMode { FIBER_NORMAL_MODE, FIBER_EXECUTION_MODE, FIBER_LAST_MODE };
    LPVOID FiberHandle[FIBER_LAST_MODE];
    bool ExecutionFinish;

    void ExecutionFiberProc();
    static VOID WINAPI ExecutionFiberProcWrapper(PVOID lpParameter);
    bool SwitchMode(FiberMode Mode);
    bool YieldExec(); // Same as SwitchMode(FIBER_NORMAL_MODE);

    bool InitCPU(); // XXX This must be called in the constructor of the child class
                    // This is due some stupid C++ base-type-while-in-base-constructor
                    // assumption ;/
    
    // Execution stuff
    virtual bool Exec_Init();
    virtual bool Exec_Decode();
    virtual bool Exec_Execute();

  public:
    CHWCPU();
    virtual const char *GetName() const;
    virtual bool Step();
};

