// Log.cpp
// Sth project
#include <cstdio>
#include <stdarg.h>

#include "CLog.h"

using namespace std;

// 
CLog::CLog() 
{
  this->LogMinimumLevel = Log::MinimumLevel;
}

// Globals
enum LogLevels Log::MinimumLevel = LOG_NORMAL;

// Msg
void Log::CMsg(LogLevels level, const char *name, void *id, const char *fmt, ...)
{
  // Log... this is just an output to stdout for now ;>
  va_list args;
  va_start(args, fmt);
  
  switch(level)
  {
    case LOG_SUPER_VERBOSE: printf("v.debug : <%s:%.8x> ", name, (unsigned int)id); break;
    case LOG_VERBOSE:       printf("debug   : <%s:%.8x> ", name, (unsigned int)id); break;
    case LOG_NORMAL:        printf("info    : <%s:%.8x> ", name, (unsigned int)id); break;
    case LOG_WARNING:       printf("warn    : <%s:%.8x> ", name, (unsigned int)id); break;
    case LOG_ERROR:         printf("error   : <%s:%.8x> ", name, (unsigned int)id); break;
    case LOG_CRITICAL:      printf("critical: <%s:%.8x> ", name, (unsigned int)id); break;
  }

  vprintf(fmt, args);
  va_end(args);

  putchar('\n');

  fflush(stdout);
}

// Msg
void Log::GMsg(LogLevels level, const char *fmt, ...)
{
  // Log... this is just an output to stdout for now ;>
  va_list args;
  va_start(args, fmt);
  
  switch(level)
  {
    case LOG_SUPER_VERBOSE: printf("v.debug : "); break;
    case LOG_VERBOSE:       printf("debug   : "); break;
    case LOG_NORMAL:        printf("info    : "); break;
    case LOG_WARNING:       printf("warn    : "); break;
    case LOG_ERROR:         printf("error   : "); break;
    case LOG_CRITICAL:      printf("critical: "); break;
  }

  vprintf(fmt, args);
  va_end(args);

  putchar('\n');

  fflush(stdout);
}

