#pragma once
// Log.h
// Sth Project

enum LogLevels
{
  LOG_SUPER_VERBOSE = 0,  // debug
  LOG_VERBOSE  = 1,       // debug
  LOG_NORMAL   = 2,       // info
  LOG_WARNING  = 3,       // warning
  LOG_ERROR    = 4,       // error
  LOG_CRITICAL = 5        // critical
};

// Class for inheritance
class CLog
{
  public:
    enum LogLevels LogMinimumLevel; // Default is NORMAL

    CLog();    
};

// Global log class
class Log
{
  public:
    static enum LogLevels MinimumLevel; // Default is NORMAL
    static void CMsg(enum LogLevels level, const char *name, void *id, const char *fmt, ...);
    static void GMsg(enum LogLevels level, const char *fmt, ...);
};

// Object/Class Log
// To use this, the class has to have GetName() method
// And has to inherit over CLog
#ifdef _MSC_VER
#  define CLOG(a,...) if(this->LogMinimumLevel <= a) { Log::CMsg(a, this->GetName(), this, __VA_ARGS__); }
#else
#  define CLOG(a,b...) if(this->LogMinimumLevel <= a) { Log::CMsg(a, this->GetName(), this, b); }
#endif

// Global Log
#ifdef _MSC_VER
#  define GLOG(a,...) if(Log::MinimumLevel <= a) { Log::GMsg(a, __VA_ARGS__); }
#else
#  define GLOG(a,b...) if(Log::MinimumLevel <= a) { Log::GMsg(a, b); }
#endif

