#pragma once
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<vector>
#include<stdint.h>

// ImageTGA32 limits the total memory size used by the bitmap to 64MB for sanity reasons.
// If you need to change it, it's hardcoded in the Load method
class ImageTGA32
{
  public: 
    #pragma pack(push, 1)     
    struct TgaHeader
    {
      unsigned char id_field;  // length of ID Field
      unsigned char c_map;     // is there a color map ? (should be 0x00)
      unsigned char img_type;  // always 2
      unsigned char color_map[5]; // ignored for 24 bits & 32 bits
      unsigned short x_origin; // the X coord of the lower left corner (0x0000)
      unsigned short y_origin; // the Y coord of the lower left corner (0x0000)
      unsigned short width;    // width of image
      unsigned short height;   // height of image
      unsigned char bpp;       // bits per pixel (8,16,24,32)
      unsigned char flip;      // 0x20 for yes
    };
    #pragma pack(pop)
    
    TgaHeader            Header;
    std::vector<uint8_t> Data; // bit map
    unsigned long        Size; // size of date tab

    ImageTGA32(); 
    bool Load(const char *FileName);
};

