[bits 16]

; MyCPU Assembler
; 16-bit Registers: r0 - r6
; 16-bit Instruction Pointer: pc alias r7
; Opcodes:
;  opcode       cycles        desc
;  00 rX rY     1             mov <rX>, <rY>
;  01 rX rY     1             add <rX>, <rY>
;  02 rX imm16  1             ldi <rX>, imm16
;  03 rX addr   2+ (avg 2.5)  ldr <rX>, addr
;  FF           1             hlt
;
;  ldr instruction cycle count depend on the
;  response time of the RAM controler; this is
;  at least one cycle for decode and comunication
;  with the ram controler, and another cycle to get
;  the data back; however, if the RAM controler is
;  very busy, this can take many cycles

%define r0 0x00
%define r1 0x01
%define r2 0x02
%define r3 0x03
%define r4 0x04
%define r5 0x05
%define r6 0x06
%define r7 0x07
%define pc 0x07

%macro mov 2
  db 0x00, %1, %2
%endmacro 

%macro add 2
  db 0x01, %1, %2
%endmacro 

%macro ldi 2
  db 0x02, %1
  dw %2
%endmacro

%macro ldr 2
  db 0x03, %1
  dw %2
%endmacro

%macro hlt 0
  db 0xff
%endmacro

start:
  ldi r0, 0x1234
  mov r1, r0
  add r0, r1
  ldr r1, 0x1234
  hlt

